#ifndef _L4_SYSCALL_H
#define _L4_SYSCALL_H	1

#include <l4/types.h>
#include <l4/kip.h>

/* <l4/bits/syscall.h> defines extern inlines for all system calls.  */
#include <l4/bits/syscall.h>

/* l4_exchange_registers control argument.  */

/* Input.  */
#define L4_XCHG_REGS_HALT		0x01
#define L4_XCHG_REGS_CANCEL_RECV	0x02
#define L4_XCHG_REGS_CANCEL_SEND	0x04
#define L4_XCHG_REGS_CANCEL_IPC		(L4_XCHG_REGS_CANCEL_RECV	\
					 | L4_XCHG_REGS_CANCEL_SEND)
#define L4_XCHG_REGS_SET_SP		0x08
#define L4_XCHG_REGS_SET_IP		0x10
#define L4_XCHG_REGS_SET_FLAGS		0x20
#define L4_XCHG_REGS_SET_USER_HANDLE	0x40
#define L4_XCHG_REGS_SET_PAGER		0x80

/* Output.  */
#define L4_XCHG_REGS_HALTED		0x01
#define L4_XCHG_REGS_RECEIVING		0x02
#define L4_XCHG_REGS_SENDING		0x04
#define L4_XCHG_REGS_IPCING		(L4_XCHG_REGS_RECEIVING		\
					 | L4_XCHG_REGS_SENDING)

/* l4_schedule return codes.  */
#define L4_SCHEDULE_ERROR		0
#define L4_SCHEDULE_DEAD		1
#define L4_SCHEDULE_INACTIVE		2
#define L4_SCHEDULE_RUNNING		3
#define L4_SCHEDULE_PENDING_SEND	4
#define L4_SCHEDULE_SENDING		5
#define L4_SCHEDULE_WAITING		6
#define L4_SCHEDULE_RECEIVING		7

#endif	/* l4/syscall.h */
